 function show_message(msg,time)
 {
  if ( typeof time == 'undefined' ) time = "1s"; 
  $("#message").html(msg);
  $("#message").show();
  $("#my_preg").show();
  $("#message").oneTime(time, 
   function()
   {
    $(this).hide(1500);
   }
  );
 }
 
 function get_list()
 {
  $.post(
	"preg_edit.php",
	{
	 task:"list"
	},
	function(data)
	{
	 if (typeof(data.error) == "undefined")
	 {
	  // Отображаем полученные данные
	  $("#sel_preg").html(data.list);
	  $("#pattern").val(data.pattern);
	  $("#subject").val(data.subject);
	  $("#note").val(data.note);
	  // Только после того как получили значения - имитируем нажатие левой кнопки 
	  // мыши по надписи "Проверить" отправляем данные на сервер и получаем результат.
	  ident = $("#sel_preg option:selected").attr("id");
	  if (ident!=0)
	   $("#sb").click();
	  else
       $("#result").html('Напишите выражение, вставьте текст и нажмите кнопку "Проверить".');	  
	 } 
	 else
	  // или сообщаем об ошибке.
	  show_message(data.error,"20s");
	},
	"json"
   );
 }
 
 
 // Двойной вызов:
 // $ - вызывается конструктор класса jQuery.
 // В качестве параметра ему передается CSS-селектор элементов документа, на которых
 // будет выполняться действие библиотеки. Элементами документа могут быть это части текста
 // заключенные в соответсвующие теги, весь документ или все окно браузера. В данном случае
 // весь документ. 
 // При этом, т.к. мы не получили значение функции $, указатель на вновь созданный объект теряется,
 // но такой подход широко используется в Web-программировании - интерпретатор содержит
 // сборщик мусора и когда объект станет не нужен, он будет автоматически уничтожен.
 // Потом сразу вызывается метод ready созданного объекта класса jQuery. 
 // В качестве параметра ему передается функция. Эта функция будет выполнятся всякий раз,
 // когда объектная модель документа (DOM) готова к использованию, т.е. после полной загрузки
 // HTML документа.
 $(document).ready(
  // Передаваемую функцию можно описать отдельно и указать её имя или определить её сразу в строке вызова.
  // Здесь её определяем сразу. При этом, если функцию планируется использовать только в одном месте,
  // она может не иметь имени.
  function()
  {
   
   
   // --- 1 - Определяем обработчик на клик по псевдо-ссылке "Мои регулярные выражения". ---
   $("#a_exp").click(
    function()
	{
     // Метод slideToggle, плавно сворачивает или разворачивает указанные элементы документа.
	 $("#my_preg").slideToggle("slow");
    }
   );
  
  
   // --- 2 - Определяем обработчик на нажатие кнопки "Проверить". ---
   // Продолжим подробно расписывать действия.
   // Дальше опять создается новый объект класса jQuery и вызывается метод click.
   // Метод click задает обработчик события "нажатие правой кнопки мыши" на те элементы документа,
   // которые были заданы при создании объекта. В данном случае - на элементы класса "a_dash".
   $("#sb").click(
    function()
	{
     // Получаем переменные
	 // С переменными можно сделать небольшое замечание. Значения многих элементов можно
	 // получать задавать многими способами например через val и html. Но после выбора
	 // способа для конкретного элемента нужно придерживаться этого способа для этого
	 // элемента на всей странице и не смешивать их.
	 // В противном случае, например если в одном месте задаем значения элемента через val,
	 // а в задаем значение этого же элемента другом через html, то значение задано не будет
	 // (останется прежним).
	 var p = $("#pattern").val(),
	     s = $("#subject").val();
     // отправляем на сервер	 
	 $.post(
	  // какому ресурсу на сервере передать переменные
      "preg_preg.php",
	  // Передаваемые данные, если переменных несколько, то массив можно указать прямо в параметрах
	  // в виде: { имя1:значение1, имя2:значение2 ...}
	  // Имена переменных можно не брать в кавычки, но лучше взять - если имя не является допустимым
      // именем, оно тоже будет корретно обработано. Кавычки можно использовать как одинарные, так и
	  // двойные.
	  {
	   'pattern':p,
	   'subject':s
	  },
	  // Функция, исполняемая после удачного завершения загрузки данных - получения ответа
	  // от сервера. Тоже можно определить прямо в параметрах и без имени.
	  // Данные от сервера получаем в параметре функции, обычно его называют data, но может
	  // любое имя.
	  function(data)
	  {
	   // Вписываем полученные данные в соответствующие элементы документа.
	   $("#result").html(data.result);
	   $("#preg_error").html(data.error);
	  },
	  // Тип получаемых данных.
	  // Обычно если не указывать, то можно получить только одну переменную,
	  // если нужно получить несколько переменных, то можно указать "json".
	  // На сервере перед отправкой переменных их нужно закодировать с помощью
	  // функции json_encode.
	  "json"
	  );
    }
   );
   
   
   // --- 3 - Задаем начальные значения для select, pattern, subject и note ---
   // Дальше все повторяется. Подробно комментировать не будем.
   // Единственная разница - здесь функция будет выполнена сразу после загрузки страницы,
   // не дожидаясь какой-либо реакции от пользователя
   get_list();
      
   
   // --- 4 - Определяем обработчик на клик по псевдо-ссылке "Добавить". ---
   $("#a_add").click(
    function()
	{
	 var p = $("#pattern").val(),
	     s = $("#subject").val(),
		 note = $("#note").val(),
		 n = $("#name").val();
	 if (n=="")
	 {
	  show_message("Ошибка: Надо указать имя записываемого выражения");
	  return;
	 }
	 $.post(
	  "preg_edit.php",
	  {
	   'task':"add",
	   'pattern':p,
	   'subject':s,
	   'note':note,
	   'name':n,
	  },
	  function(data)
	  {
	   if (typeof(data.error) == "undefined")
	   {
	    // добавляем в конец select новый option
		$("#sel_preg").append('<option id="'+data.id+'">'+n+'</option>');
		// делаем его выбранным
		$("#sel_preg :last").attr("selected", "selected");
		show_message('Запись "'+n+'" добавлена');
		$("#sb").click();
	   }
	   else
		show_message(data.error, "20s");
	  },
	  // Удобно даже если нужно получить значение одной переменной, получать две.
	  // Первая - сама переменная, вторая - сообщение о возможной ошибке.
	  "json"
	  );
	}
   );
   
   
   // --- 5 - Определяем обработчик на клик по псевдо-ссылке "Удалить". ---
   $("#a_del").click(
    function()
	{
	 // получаем значение атрибута "id" выбранного элемента в select
	 ident = $("#sel_preg option:selected").attr("id");
	 if (ident != 0)
	 {
	  $.post(
	  "preg_edit.php",
	  {
	   task:"delete",
	   id:ident
	  },
	  function(data)
	  {
	   if ( (typeof(data.error) == "undefined") )
	   {
	    // удаляем выбранный элемент
		$("#sel_preg :selected").remove();
		// делаем выбранным последний элемент
		$("#sel_preg :last").attr("selected", "selected");
		// кликаем по select - обновляем окна
		$("#sel_preg").change();
		show_message("Запись id = "+data.id+" удалена");
	   }
	   else
	   	// или сообщаем об ошибке
		show_message(data.error, "20s");
	  },
	  // удобно даже для одной переменной получать два значения
	  // одно - сама переменная, второе - сообщения об ошибках
	  "json"
	  );
	 }
	 else
	  show_message("Ошибка: Надо выбрать ранее сохраненное выражение");
	}
   );
   
   
   // --- 6 - Определяем обработчик на клик по псевдо-ссылке "Обновить". ---
   $("#a_update").click(
    function()
	{
	 // получаем значение атрибута "id" выбранного элемента в select
	 ident = $("#sel_preg option:selected").attr("id");
	 if (ident != 0)
	 {
	  var p = $("#pattern").val(),
	      s = $("#subject").val(),
		  note = $("#note").val();
	  $.post(
	   "preg_edit.php",
	   {
	    'task':"update",
	    'id':ident,
	    'pattern':p,
	    'subject':s,
		'note':note
	   },
	  function(data)
	  {
	   if ( typeof(data.error) == "undefined" )
	    show_message("Запись id = "+data.id+" обновлена");
	   else
	   	show_message(data.error, "20s");
	  },
	  // удобно даже для одной переменной получать два значения
	  // одно - сама переменная, второе - сообщения об ошибках
	  "json"
	  );
	  // кликаем по "Проверить"
	  $("#sb").click();
	 }
	 else
	  show_message("Ошибка: Надо выбрать ранее сохраненное выражение");
	}
   );
   
   // --- 7 - Определяем обработчик на клик по псевдо-ссылке "Удалить все". ---
   $("#a_clear").click(
    function()
	{
	 // переменные здесь не нужны, полномочия определяются по user_id
	 $.post(
	  "preg_edit.php",
	  {
	  'task':"clear"
	  },
	  function(data)
	  {
	   if ( typeof(data.error) == "undefined" )
	   {
	    get_list();
	    show_message("Все выражения удалены");
	   }
	   else
	   	show_message(data.error, "20s");
	  },
	  // удобно даже для одной переменной получать два значения
	  // одно - сама переменная, второе - сообщения об ошибках
	  "json"
	  );
	}
   );
   
   
   // --- 8 - Определяем обработчик на клик по псевдо-ссылке "Вернуть в начальное состояние". ---
   $("#a_init").click(
    function()
	{
	 // переменные здесь не нужны, полномочия определяются по user_id
	 $.post(
	  "preg_edit.php",
	  {
	  'task':"init"
	  },
	  function(data)
	  {
	   if ( typeof(data.error) == "undefined" )
	   {
	    get_list();
		show_message("Все пользовательские выражения удалены. Начальные выражения восстановлены");
	   }
	   else
	   	show_message(data.error, "20s");
	  },
	  // удобно даже для одной переменной получать два значения
	  // одно - сама переменная, второе - сообщения об ошибках
	  "json"
	  );
	}
   );
   
   // --- 9 - определяем обработчик на изменение select ---
   $("#sel_preg").change(
    function()
	{
	 ident = $("#sel_preg option:selected").attr("id");
	 if (ident != 0)
	 {
	  $.post(
	   "preg_edit.php",
	   {
	    task:"get",
	    id:ident
	   },
	   function(data)
	   {
	    if ( (typeof(data.error) == "undefined") )
		{
		 $("#pattern").val(data.pattern);
		 $("#subject").val(data.subject);
		 $("#note").val(data.note);
	     // Кликаем по "Проверить"
         $("#sb").click();
		 $("#error2").html("");
		}
        else
	     show_message(data.error, "20s");
       },
	   "json"
	  );
	 }
	 else
	 {
	  $("#pattern").val("");
	  $("#subject").val("");
	  $("#note").val("");
	  $("#result").html('Напишите выражение, вставьте текст и нажмите кнопку "Проверить".');
	 }
	}
   );
   
   // --- 10 - Определяем обработчик на клик по псевдо-ссылке "О сервисе". ---
   $("#a_about").click(
    function()
	{
	 $("#about").slideToggle("slow");
    }
   );
   

  // Вспоминаем, что все наши функции были определены внутри параметра-функции метода ready
  // закрываем функцию.
  }
 // Закрываем вызов метода.
 );
 
 // Таким образом, первой частью вышеприведенного кода задаются следующие действия:
 // 1. Ожидаем готовности DOM. При этом создается 1-ый объект класса jQuery.
 // 2. Как только модель готова, ставим обработчик события "нажатие правой кнопки мыши" на
 //    объекты-теги, у которых атрибут id равен a_exp - это у нас ссылка "Мои регулярные выражения".
 //    Ссылка фиктивная - атрибута href у неё нет. При этом создается 2-ый объект класса jQuery. 
 // 3. Ждем события.
 // 4. После возникновения события вызывается функция обработчик, которая создает новый 3-ий экземпляр класса
 //    jQuery в котором вызывает метод slideToggle. При этом те элементы HTML-документа , у которых атрибут
 //    id равны my_preg, сворачиваюся, если были развернуты, или разворачиваюся, если были свернуты. 
 //    Возможно после того, как действие будет выполнено, объект будет уничтожен.
 // Остальные части действуют аналогично.
 //
 // Также следует заметить, что нет никакой необходимости описывать все используемые функции  в одном
 // блоке сразу в параметрах. Но если они маленькие, то такой подход позволяет не задумываться об
 // именах функций, а также немного сокращает объем кода.